# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Cosmosdb::Mgmt::V2015_04_08
  module Models
    #
    # An Azure Cosmos DB SQL database.
    #
    class SqlDatabase < Resource

      include MsRestAzure

      # @return [String] Name of the Cosmos DB SQL database
      attr_accessor :sql_database_id

      # @return [String] A system generated property. A unique identifier.
      attr_accessor :_rid

      # @return A system generated property that denotes the last updated
      # timestamp of the resource.
      attr_accessor :_ts

      # @return [String] A system generated property representing the resource
      # etag required for optimistic concurrency control.
      attr_accessor :_etag

      # @return [String] A system generated property that specified the
      # addressable path of the collections resource.
      attr_accessor :_colls

      # @return [String] A system generated property that specifies the
      # addressable path of the users resource.
      attr_accessor :_users


      #
      # Mapper for SqlDatabase class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SqlDatabase',
          type: {
            name: 'Composite',
            class_name: 'SqlDatabase',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              sql_database_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.id',
                type: {
                  name: 'String'
                }
              },
              _rid: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties._rid',
                type: {
                  name: 'String'
                }
              },
              _ts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties._ts',
                type: {
                  name: 'Object'
                }
              },
              _etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties._etag',
                type: {
                  name: 'String'
                }
              },
              _colls: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties._colls',
                type: {
                  name: 'String'
                }
              },
              _users: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties._users',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
