# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Cosmosdb::Mgmt::V2020_03_01
  module Models
    #
    # Model object.
    #
    #
    class ThroughputSettingsGetPropertiesResource

      include MsRestAzure

      # @return [Integer] Value of the Cosmos DB resource throughput. Either
      # throughput is required or provisionedThroughputSettings is required,
      # but not both.
      attr_accessor :throughput

      # @return [ProvisionedThroughputSettingsResource] Cosmos DB resource for
      # provisioned throughput settings. Either throughput is required or
      # provisionedThroughputSettings is required, but not both.
      attr_accessor :provisioned_throughput_settings

      # @return [String] The minimum throughput of the resource
      attr_accessor :minimum_throughput

      # @return [String] The throughput replace is pending
      attr_accessor :offer_replace_pending

      # @return [String] A system generated property. A unique identifier.
      attr_accessor :_rid

      # @return A system generated property that denotes the last updated
      # timestamp of the resource.
      attr_accessor :_ts

      # @return [String] A system generated property representing the resource
      # etag required for optimistic concurrency control.
      attr_accessor :_etag


      #
      # Mapper for ThroughputSettingsGetPropertiesResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ThroughputSettingsGetProperties_resource',
          type: {
            name: 'Composite',
            class_name: 'ThroughputSettingsGetPropertiesResource',
            model_properties: {
              throughput: {
                client_side_validation: true,
                required: false,
                serialized_name: 'throughput',
                type: {
                  name: 'Number'
                }
              },
              provisioned_throughput_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'provisionedThroughputSettings',
                type: {
                  name: 'Composite',
                  class_name: 'ProvisionedThroughputSettingsResource'
                }
              },
              minimum_throughput: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'minimumThroughput',
                type: {
                  name: 'String'
                }
              },
              offer_replace_pending: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'offerReplacePending',
                type: {
                  name: 'String'
                }
              },
              _rid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: '_rid',
                type: {
                  name: 'String'
                }
              },
              _ts: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: '_ts',
                type: {
                  name: 'Object'
                }
              },
              _etag: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: '_etag',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
