# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Cosmosdb::Mgmt::V2021_01_15
  module Models
    #
    # Model object.
    #
    #
    class MongoDBCollectionGetPropertiesResource

      include MsRestAzure

      # @return [String] Name of the Cosmos DB MongoDB collection
      attr_accessor :id

      # @return [Hash{String => String}] A key-value pair of shard keys to be
      # applied for the request.
      attr_accessor :shard_key

      # @return [Array<MongoIndex>] List of index keys
      attr_accessor :indexes

      # @return [Integer] Analytical TTL.
      attr_accessor :analytical_storage_ttl

      # @return [String] A system generated property. A unique identifier.
      attr_accessor :_rid

      # @return [Float] A system generated property that denotes the last
      # updated timestamp of the resource.
      attr_accessor :_ts

      # @return [String] A system generated property representing the resource
      # etag required for optimistic concurrency control.
      attr_accessor :_etag


      #
      # Mapper for MongoDBCollectionGetPropertiesResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MongoDBCollectionGetProperties_resource',
          type: {
            name: 'Composite',
            class_name: 'MongoDBCollectionGetPropertiesResource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              shard_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'shardKey',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              indexes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'indexes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'MongoIndexElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'MongoIndex'
                      }
                  }
                }
              },
              analytical_storage_ttl: {
                client_side_validation: true,
                required: false,
                serialized_name: 'analyticalStorageTtl',
                type: {
                  name: 'Number'
                }
              },
              _rid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: '_rid',
                type: {
                  name: 'String'
                }
              },
              _ts: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: '_ts',
                type: {
                  name: 'Double'
                }
              },
              _etag: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: '_etag',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
